// Auto-generated. Do not edit!

// (in-package cob_light.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LightMode = require('../msg/LightMode.js');

//-----------------------------------------------------------


//-----------------------------------------------------------

class SetLightModeRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.mode = null;
    }
    else {
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = new LightMode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetLightModeRequest
    // Serialize message field [mode]
    bufferOffset = LightMode.serialize(obj.mode, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetLightModeRequest
    let len;
    let data = new SetLightModeRequest(null);
    // Deserialize message field [mode]
    data.mode = LightMode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += LightMode.getMessageSize(object.mode);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'cob_light/SetLightModeRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'cf64533ba011e7f531cecce5a35c9b83';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    cob_light/LightMode mode
    
    ================================================================================
    MSG: cob_light/LightMode
    uint8 mode                         # mode to switch on
    
    float32                frequency   # in Hz
    float32                timeout     # in s, requested mode will be executed for max timeout s.
                                       # default is 0 and means no timeout.
    int32                  pulses      # specifies the amount of pulses which will be executed.
                                       # eg: mode = flash, pulses = 2. Means the light will flash two times
    int8                   priority    # priority [-20,20] default = 0. Modes with same or higher priorities will
                                       # be executed.
    std_msgs/ColorRGBA[]   colors      # array of colors.
                                       # size > 1: each color represent one led (size should match the amount of leds)
                                       # size = 1: one color for all leds or color for specific mode
                                       # size = 0: undefined
    cob_light/Sequence[]   sequences   # an array of sequence definitions, used only if mode is set to SEQ
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    ================================================================================
    MSG: cob_light/Sequence
    std_msgs/ColorRGBA   color       #sequence color
    float32              hold_time   #time how long the color should be hold [s]
    float32              cross_time  #time how long it take to fade to this color [s]
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetLightModeRequest(null);
    if (msg.mode !== undefined) {
      resolved.mode = LightMode.Resolve(msg.mode)
    }
    else {
      resolved.mode = new LightMode()
    }

    return resolved;
    }
};

class SetLightModeResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.active_mode = null;
      this.active_priority = null;
      this.track_id = null;
    }
    else {
      if (initObj.hasOwnProperty('active_mode')) {
        this.active_mode = initObj.active_mode
      }
      else {
        this.active_mode = 0;
      }
      if (initObj.hasOwnProperty('active_priority')) {
        this.active_priority = initObj.active_priority
      }
      else {
        this.active_priority = 0;
      }
      if (initObj.hasOwnProperty('track_id')) {
        this.track_id = initObj.track_id
      }
      else {
        this.track_id = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetLightModeResponse
    // Serialize message field [active_mode]
    bufferOffset = _serializer.uint8(obj.active_mode, buffer, bufferOffset);
    // Serialize message field [active_priority]
    bufferOffset = _serializer.uint8(obj.active_priority, buffer, bufferOffset);
    // Serialize message field [track_id]
    bufferOffset = _serializer.uint64(obj.track_id, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetLightModeResponse
    let len;
    let data = new SetLightModeResponse(null);
    // Deserialize message field [active_mode]
    data.active_mode = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [active_priority]
    data.active_priority = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [track_id]
    data.track_id = _deserializer.uint64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 10;
  }

  static datatype() {
    // Returns string type for a service object
    return 'cob_light/SetLightModeResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '44b6bbe013cafd2810aef2660066a5b8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    uint8 active_mode
    uint8 active_priority
    uint64 track_id
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetLightModeResponse(null);
    if (msg.active_mode !== undefined) {
      resolved.active_mode = msg.active_mode;
    }
    else {
      resolved.active_mode = 0
    }

    if (msg.active_priority !== undefined) {
      resolved.active_priority = msg.active_priority;
    }
    else {
      resolved.active_priority = 0
    }

    if (msg.track_id !== undefined) {
      resolved.track_id = msg.track_id;
    }
    else {
      resolved.track_id = 0
    }

    return resolved;
    }
};

module.exports = {
  Request: SetLightModeRequest,
  Response: SetLightModeResponse,
  md5sum() { return 'f950166d97058c12e842261aa35075dd'; },
  datatype() { return 'cob_light/SetLightMode'; }
};
